#include "header\gba.h"
#include "header\bg.h"
#include "header\timer.h"
#include "header\dma.h"
#include "header\irq.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\blend.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include "resource.h"
#include "resource\BGFont.h"
//#include "resource\BitMapFont.h"

#include <stdlib.h>

//---------------------------------------------------------------------------
//}bṽTCY
#define MAP_SIZE_CX      8
#define MAP_SIZE_CY      8

//}bvp̒`
#define MAP_MINE_NUMBER  100

//\}bvp̒`
#define MAP_OPEN         0
#define MAP_BLOCK        2
#define MAP_FLAG         4
#define MAP_DOUBT        6

//n̐
#define MAX_MINE         5

//BG̃^C
#define BG_TILE_BLACK    0
#define BG_TILE_BLOCK    2
#define BG_TILE_FLAG     4
#define BG_TILE_DOUBT    6
#define BG_TILE_EMPTY    8
#define BG_TILE_MINE     10
#define BG_TILE_NUMBER1  12
#define BG_TILE_NUMBER2  14
#define BG_TILE_NUMBER3  16
#define BG_TILE_NUMBER4  18
#define BG_TILE_NUMBER5  20
#define BG_TILE_NUMBER6  22
#define BG_TILE_NUMBER7  24
#define BG_TILE_NUMBER8  26

//J[\ړ
#define UNIT_VECT_UP    0x01
#define UNIT_VECT_DOWN  0x02
#define UNIT_VECT_RIGHT 0x04
#define UNIT_VECT_LEFT  0x08
#define UNIT_VECT_NONE  0x00

#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)>(b))?(b):(a))
//---------------------------------------------------------------------------
typedef struct {
	s16 x;
	s16 y;
	u16 cx;
	u16 cy;
	u8  vect;
	s16 MinX;		//ړ
	s16 MinY;
	s16 MaxX;
	s16 MaxY;
	u16 SprNo;
	u16 SprTile;
	u16 SprSize;
	u16 SprForm;
	u8  OpenCnt;
	u8  EndFlag;
} ST_CURSOR;

ST_CURSOR CURSOR;

u8 MapDisp  [MAP_SIZE_CX][MAP_SIZE_CY];	//}bv̕\pɎgp
u8 MapInside[MAP_SIZE_CX][MAP_SIZE_CY];	//}bv̓pɎgp
//---------------------------------------------------------------------------
u8 BG2Chr;
u8 BG2Map;
u8 BG2Col;

u8 BG3Chr;
u8 BG3Map;
u8 BG3Col;

u8 KeyOld;
u8 KeyCount;
//---------------------------------------------------------------------------
void Init();
void InitMap();
void InitCursor();

void CalcMapClear();
void CalcMapPutMine();
void CalcMapMineSide(s16 xm, s16 ym);

void DrawCursor();
void DrawOpenBlock(s16 x, s16 y);
void DrawMap();
void DrawMapTile(u8 x, u8 y, u8 tileNo);
void DrawMapClear();
void DrawMapMarker();

void Cursor();
void MoveUnit(ST_CURSOR* p);
u8   ChkMoveUnit(ST_CURSOR* p);

void CursorOpenBlock(s16 mx, s16 my);

u8   ChkGameClear();
//---------------------------------------------------------------------------
int main(void)
{
	WaitKey(KEY_A);	//srand

	Init();
	InitMap();
	InitCursor();
	SetMode(MODE_0 | BG2_ENABLE | BG3_ENABLE | OBJ_ENABLE | OBJ_MAP_2D);

	for(;;)
	{
		WaitForVsync();
		Cursor();
		
		//NA
		if( ChkGameClear() == TRUE || CURSOR.EndFlag == TRUE)
		{
			break;
		}
	}

	if(CURSOR.EndFlag == TRUE) BGDrawStr(BG2Map, 1, 19, (u8*)"Game  Over!");
	else                       BGDrawStr(BG2Map, 1, 19, (u8*)"Game Clear!");

	for(;;){}
	return 0;
}
//---------------------------------------------------------------------------
void Init()
{
	//EFCgRg[
	REG_WSCNT = CST_ROM0_1ST_3WAIT | CST_ROM0_2ND_1WAIT;

	//BG
	//BG2 Q[p
	//BG3 \p
	BG2Chr = 1;
	BG2Map = 0;
	BG2Col = 0;

	BG3Chr = 2;
	BG3Map = 1;
	BG3Col = 1;

	REG_BG2CNT = (BG_SIZEA_256_256    | BG_COLOR_16        |
				  BG_CHARBASE(BG2Chr) | BG_MAPBASE(BG2Map) | 0);

	REG_BG3CNT = (BG_SIZEA_256_256    | BG_COLOR_16        |
				  BG_CHARBASE(BG3Chr) | BG_MAPBASE(BG3Map) | 0);

	BGSetPal16  (BG2Col, (u16*)BGFont_palette);
	BGSetChrData(BG2Chr, (u16*)BGFont_data, BGFont_DATA_SIZE);

	BGSetPal16  (BG3Col, (u16*)&game_bg_pal_bin);
	BGSetChrData(BG3Chr, (u16*)&game_bg_img_bin, 2048);
	BGSetPalMap (BG3Map, 2048, 1);

	//Sprite
	SpriteInit();
	SpriteSetPal16((u16*)&game_spr_pal_bin);
	SpriteSetData ((u16*)&game_spr_img_bin, 2048);

	//L[
	KeyInit();
	KeyOld = 0x0000;
	KeyCount = 0;
}
//---------------------------------------------------------------------------
void DrawMapTile(u8 x, u8 y, u8 tileNo)
{
	x*=2; y*=2;
	BGDrawChar(BG3Map, x+0, y+0, BG3Col, tileNo+0 );
	BGDrawChar(BG3Map, x+1, y+0, BG3Col, tileNo+1 );
	BGDrawChar(BG3Map, x+0, y+1, BG3Col, tileNo+32);
	BGDrawChar(BG3Map, x+1, y+1, BG3Col, tileNo+33);
}
//---------------------------------------------------------------------------
void InitMap()
{
	//Map̏
	CalcMapClear();
	DrawMapClear();

	//Mine̐ݒu
	CalcMapPutMine();

	//Map\
	DrawMap();
}
//---------------------------------------------------------------------------
void DrawMapClear()
{
	u8 x,y;

	for(y=0; y<MAP_SIZE_CY; y++)
	{
		for(x=0; x<MAP_SIZE_CX; x++)
		{
			DrawMapTile(x, y, BG_TILE_BLACK);
		}
	}
}
//---------------------------------------------------------------------------
void CalcMapClear()
{
	u8 x,y;

	for(y=0; y<MAP_SIZE_CY; y++)
	{
		for(x=0; x<MAP_SIZE_CX; x++)
		{
			MapDisp  [x][y] = MAP_BLOCK;
			MapInside[x][y] = 0;
		}
	}
}
//---------------------------------------------------------------------------
void CalcMapPutMine()
{
	u16 MineCnt = 0;
	s16 x,y;

	while(MineCnt < MAX_MINE)
	{
		x = rand() % MAP_SIZE_CX;
		y = rand() % MAP_SIZE_CY;

		if(MapInside[x][y] != MAP_MINE_NUMBER)
		{
			MapInside[x][y] = MAP_MINE_NUMBER;
			MineCnt++;

			//ݒun̎ӏXV
			CalcMapMineSide(x,y);
		}
	}
}
//---------------------------------------------------------------------------
void CalcMapMineSide(s16 mx, s16 my)
{
	s16 x,y;

	for(y=MAX(my-1,0); y<=MIN(my+1,MAP_SIZE_CY-1); y++)
	{
		for(x=MAX(mx-1,0); x<=MIN(mx+1,MAP_SIZE_CX-1); x++)
		{
			if(MapInside[x][y] != MAP_MINE_NUMBER)
			{
				MapInside[x][y]++;
			}
		}
	}
}
//---------------------------------------------------------------------------
void DrawMap()
{
	u8 x,y;

	for(y=0; y<MAP_SIZE_CY; y++)
	{
		for(x=0; x<MAP_SIZE_CX; x++)
		{
			DrawMapTile(x, y, BG_TILE_BLOCK);
		}
	}
}
//---------------------------------------------------------------------------
void InitCursor()
{
	CURSOR.x       = 0;
	CURSOR.y       = 0;
	CURSOR.cx      = 16;
	CURSOR.cy      = 16;
	CURSOR.vect    = 16;
	CURSOR.MinX    = 0;			//ړ
	CURSOR.MaxX    = MAP_SIZE_CX;
	CURSOR.MinY    = 0;
	CURSOR.MaxY    = MAP_SIZE_CY;

	CURSOR.SprNo   = 0;
	CURSOR.SprTile = 0;
	CURSOR.SprSize = SP_SIZE_16;
	CURSOR.SprForm = SP_SQUARE;

	CURSOR.OpenCnt = 0;
	CURSOR.EndFlag = 0;

	SpriteSetSize(CURSOR.SprNo, CURSOR.SprSize, CURSOR.SprForm, SP_COLOR_16);
	SpriteSetChr (CURSOR.SprNo, CURSOR.SprTile);
	SpriteMove   (CURSOR.SprNo, CURSOR.x, CURSOR.y);
}
//---------------------------------------------------------------------------
void Cursor()
{
	u8 Key = KeyInput();

	CURSOR.vect = UNIT_VECT_NONE;

	//L[X|X
	if(Key == 0x00 && KeyOld != Key)
	{
		KeyCount = 0;
		KeyOld   = Key;
		return;
	}
	if(KeyCount++ <= 2)
	{
		return;
	}

	KeyCount = 0;

	if(Key & KEY_UP   ) CURSOR.vect |= UNIT_VECT_UP;
	if(Key & KEY_DOWN ) CURSOR.vect |= UNIT_VECT_DOWN;
	if(Key & KEY_LEFT ) CURSOR.vect |= UNIT_VECT_LEFT;
	if(Key & KEY_RIGHT) CURSOR.vect |= UNIT_VECT_RIGHT;

	if(Key & KEY_B) DrawMapMarker();
	if(Key & KEY_A) CursorOpenBlock(CURSOR.x, CURSOR.y);

	if( ChkMoveUnit(&CURSOR) == TRUE )
	{
		MoveUnit(&CURSOR);
		DrawCursor();
	}
}
//---------------------------------------------------------------------------
//ړ͈ړ\`FbN
u8 ChkMoveUnit(ST_CURSOR* p)
{
	s16 tx1 = p->x;
	s16 ty1 = p->y;

	if(p->vect & UNIT_VECT_UP   ) ty1--;
	if(p->vect & UNIT_VECT_DOWN ) ty1++;
	if(p->vect & UNIT_VECT_LEFT ) tx1--;
	if(p->vect & UNIT_VECT_RIGHT) tx1++;

	if(tx1< CURSOR.MinX || ty1< CURSOR.MinY) return FALSE;
	if(tx1>=CURSOR.MaxX || ty1>=CURSOR.MaxY) return FALSE;

	return TRUE;
}
//---------------------------------------------------------------------------
void MoveUnit(ST_CURSOR* p)
{
	if(p->vect & UNIT_VECT_UP   ) p->y--;
	if(p->vect & UNIT_VECT_DOWN ) p->y++;
	if(p->vect & UNIT_VECT_LEFT ) p->x--;
	if(p->vect & UNIT_VECT_RIGHT) p->x++;
}
//---------------------------------------------------------------------------
void DrawCursor()
{
	SpriteMove(CURSOR.SprNo, CURSOR.x*CURSOR.cx, CURSOR.y*CURSOR.cy);
}
//---------------------------------------------------------------------------
//\p}bvɃ}[J
void DrawMapMarker()
{
	u16 x = CURSOR.x;
	u16 y = CURSOR.y;
	
	if(MapDisp[x][y] == MAP_OPEN)
	{
		return;
	}

	if(MapDisp[x][y] == MAP_BLOCK)      MapDisp[x][y] = MAP_FLAG;
	else if(MapDisp[x][y] == MAP_FLAG)  MapDisp[x][y] = MAP_DOUBT;
	else if(MapDisp[x][y] == MAP_DOUBT) MapDisp[x][y] = MAP_BLOCK;

	DrawMapTile(x, y, MapDisp[x][y]);
}
//---------------------------------------------------------------------------
void CursorOpenBlock(s16 mx, s16 my)
{
	if(MapDisp[mx][my] == MAP_OPEN)
	{
		return;
	}

	if(MapInside[mx][my] > 0)
	{
		DrawOpenBlock(mx, my);
	}
	else if(MapInside[mx][my] == 0)
	{
		DrawOpenBlock(mx, my);

		s16 x, y;
		for(y=MAX(my-1,0); y<=MIN(my+1,MAP_SIZE_CY-1); y++)
		{
			for(x=MAX(mx-1,0); x<=MIN(mx+1,MAP_SIZE_CX-1); x++)
			{
				CursorOpenBlock(x, y);
			}
		}
	}
}
//---------------------------------------------------------------------------
void DrawOpenBlock(s16 x, s16 y)
{
	u16 Tile=0;
	switch(MapInside[x][y])
	{
		case 0:               Tile = BG_TILE_EMPTY;   break;
		case 1:               Tile = BG_TILE_NUMBER1; break;
		case 2:               Tile = BG_TILE_NUMBER2; break;
		case 3:               Tile = BG_TILE_NUMBER3; break;
		case 4:               Tile = BG_TILE_NUMBER4; break;
		case 5:               Tile = BG_TILE_NUMBER5; break;
		case 6:               Tile = BG_TILE_NUMBER6; break;
		case 7:               Tile = BG_TILE_NUMBER7; break;
		case MAP_MINE_NUMBER: Tile = BG_TILE_MINE;
		                      CURSOR.EndFlag=TRUE;    break;
		default:                                      break;
	}
	DrawMapTile(x, y, Tile);

	MapDisp[x][y] = MAP_OPEN;
	CURSOR.OpenCnt++;
}
//---------------------------------------------------------------------------
u8 ChkGameClear()
{
	if(CURSOR.OpenCnt >= (MAP_SIZE_CX * MAP_SIZE_CY - MAX_MINE))
	{
		return TRUE;
	}
	return FALSE;
}
